import domain.Domain;

import java.time.LocalDateTime;
import java.util.Optional;
import java.util.function.Supplier;

public class SupplierExamples {

  public static void main(String[] args) {
    simpleExample();
    supplierToReturnObject();
  }

  private static void supplierToReturnObject() {
    System.out.println(factory(Domain::new));
    System.out.println(factory(() -> new Domain("hi", 10)));
  }

  private static Domain factory(Supplier<? extends Domain> s) {
    Domain domain = s.get();
    if(!Optional.ofNullable(domain.getName()).isPresent()) {
      domain.setName("Hello");
      domain.setScore(100);
    }
    return domain;
  }

  private static void simpleExample() {
    Supplier<LocalDateTime> supplier = () -> LocalDateTime.now();
    System.out.println(supplier.get());
  }

}
